org.apache.commons.beanutils

## Class MethodUtils

- java.lang.Object
- - org.apache.commons.beanutils.MethodUtils

-     public class MethodUtils
      extends Object

  Utility reflection methods focused on methods in general rather than properties in particular.

  ### Known Limitations

  #### Accessing Public Methods In A Default Access Superclass

  There is an issue when invoking public methods contained in a default access superclass. Reflection locates these methods fine and correctly assigns them as public. However, an `IllegalAccessException` is thrown if the method is invoked.

  `MethodUtils` contains a workaround for this situation. It will attempt to call `setAccessible` on this method. If this call succeeds, then the method can be invoked as normal. This call will only succeed when the application has sufficient security privilages. If this call fails then a warning will be logged and the method may fail.

  Version:
    $Id: MethodUtils.java 1746219 2016-05-31 05:05:09Z ggregory $

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MethodUtils()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `clearCache()` Clear the method cache.
    `static Method` | `getAccessibleMethod(Class<?> clazz, Method method)` Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method.
    `static Method` | `getAccessibleMethod(Class<?> clazz, String methodName, Class<?> parameterType)` Return an accessible method (that is, one that can be invoked via reflection) with given name and a single parameter.
    `static Method` | `getAccessibleMethod(Class<?> clazz, String methodName, Class<?>[] parameterTypes)` Return an accessible method (that is, one that can be invoked via reflection) with given name and parameters.
    `static Method` | `getAccessibleMethod(Method method)` Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method.
    `static Method` | `getMatchingAccessibleMethod(Class<?> clazz, String methodName, Class<?>[] parameterTypes)` Find an accessible method that matches the given name and has compatible parameters.
    `static Class<?>` | `getPrimitiveType(Class<?> wrapperType)` Gets the class for the primitive type corresponding to the primitive wrapper class given.
    `static Class<?>` | `getPrimitiveWrapper(Class<?> primitiveType)` Gets the wrapper object class for the given primitive type class.
    `static Object` | `invokeExactMethod(Object object, String methodName, Object arg)` Invoke a method whose parameter type matches exactly the object type.
    `static Object` | `invokeExactMethod(Object object, String methodName, Object[] args)` Invoke a method whose parameter types match exactly the object types.
    `static Object` | `invokeExactMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes)` Invoke a method whose parameter types match exactly the parameter types given.
    `static Object` | `invokeExactStaticMethod(Class<?> objectClass, String methodName, Object arg)` Invoke a static method whose parameter type matches exactly the object type.
    `static Object` | `invokeExactStaticMethod(Class<?> objectClass, String methodName, Object[] args)` Invoke a static method whose parameter types match exactly the object types.
    `static Object` | `invokeExactStaticMethod(Class<?> objectClass, String methodName, Object[] args, Class<?>[] parameterTypes)` Invoke a static method whose parameter types match exactly the parameter types given.
    `static Object` | `invokeMethod(Object object, String methodName, Object arg)` Invoke a named method whose parameter type matches the object type.
    `static Object` | `invokeMethod(Object object, String methodName, Object[] args)` Invoke a named method whose parameter type matches the object type.
    `static Object` | `invokeMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes)` Invoke a named method whose parameter type matches the object type.
    `static Object` | `invokeStaticMethod(Class<?> objectClass, String methodName, Object arg)` Invoke a named static method whose parameter type matches the object type.
    `static Object` | `invokeStaticMethod(Class<?> objectClass, String methodName, Object[] args)` Invoke a named static method whose parameter type matches the object type.
    `static Object` | `invokeStaticMethod(Class<?> objectClass, String methodName, Object[] args, Class<?>[] parameterTypes)` Invoke a named static method whose parameter type matches the object type.
    `static boolean` | `isAssignmentCompatible(Class<?> parameterType, Class<?> parameterization)` Determine whether a type can be used as a parameter in a method invocation.
    `static void` | `setCacheMethods(boolean cacheMethods)` Set whether methods should be cached for greater performance or not, default is `true`.
    `static Class<?>` | `toNonPrimitiveClass(Class<?> clazz)` Find a non primitive representation for given primitive class.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MethodUtils

          public MethodUtils()

  - ### Method Detail

    - #### setCacheMethods

          public static void setCacheMethods(boolean cacheMethods)

      Set whether methods should be cached for greater performance or not, default is `true`.
      Parameters:
        `cacheMethods` - `true` if methods should be cached for greater performance, otherwise `false`
      Since:
        1.8.0

    - #### clearCache

          public static int clearCache()

      Clear the method cache.
      Returns:
        the number of cached methods cleared
      Since:
        1.8.0

    - #### invokeMethod

          public static Object invokeMethod(Object object,
                                            String methodName,
                                            Object arg)
                                     throws NoSuchMethodException,
                                            IllegalAccessException,
                                            InvocationTargetException

      Invoke a named method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactMethod()`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      This is a convenient wrapper for `invokeMethod(Object object,String methodName,Object [] args)`.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `arg` - use this argument. May be null (this will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeMethod

          public static Object invokeMethod(Object object,
                                            String methodName,
                                            Object[] args)
                                     throws NoSuchMethodException,
                                            IllegalAccessException,
                                            InvocationTargetException

      Invoke a named method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args)`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      This is a convenient wrapper for `invokeMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeMethod

          public static Object invokeMethod(Object object,
                                            String methodName,
                                            Object[] args,
                                            Class<?>[] parameterTypes)
                                     throws NoSuchMethodException,
                                            IllegalAccessException,
                                            InvocationTargetException

      Invoke a named method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
        `parameterTypes` - match these parameters - treat null as empty array
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeExactMethod

          public static Object invokeExactMethod(Object object,
                                                 String methodName,
                                                 Object arg)
                                          throws NoSuchMethodException,
                                                 IllegalAccessException,
                                                 InvocationTargetException

      Invoke a method whose parameter type matches exactly the object type.

      This is a convenient wrapper for `invokeExactMethod(Object object,String methodName,Object [] args)`.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `arg` - use this argument. May be null (this will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeExactMethod

          public static Object invokeExactMethod(Object object,
                                                 String methodName,
                                                 Object[] args)
                                          throws NoSuchMethodException,
                                                 IllegalAccessException,
                                                 InvocationTargetException

      Invoke a method whose parameter types match exactly the object types.

      This uses reflection to invoke the method obtained from a call to `getAccessibleMethod()`.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeExactMethod

          public static Object invokeExactMethod(Object object,
                                                 String methodName,
                                                 Object[] args,
                                                 Class<?>[] parameterTypes)
                                          throws NoSuchMethodException,
                                                 IllegalAccessException,
                                                 InvocationTargetException

      Invoke a method whose parameter types match exactly the parameter types given.

      This uses reflection to invoke the method obtained from a call to `getAccessibleMethod()`.

      Parameters:
        `object` - invoke method on this object
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
        `parameterTypes` - match these parameters - treat null as empty array
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection

    - #### invokeExactStaticMethod

          public static Object invokeExactStaticMethod(Class<?> objectClass,
                                                       String methodName,
                                                       Object[] args,
                                                       Class<?>[] parameterTypes)
                                                throws NoSuchMethodException,
                                                       IllegalAccessException,
                                                       InvocationTargetException

      Invoke a static method whose parameter types match exactly the parameter types given.

      This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
        `parameterTypes` - match these parameters - treat null as empty array
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### invokeStaticMethod

          public static Object invokeStaticMethod(Class<?> objectClass,
                                                  String methodName,
                                                  Object arg)
                                           throws NoSuchMethodException,
                                                  IllegalAccessException,
                                                  InvocationTargetException

      Invoke a named static method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactMethod(Object, String, Object[], Class[])`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      This is a convenient wrapper for `invokeStaticMethod(Class objectClass,String methodName,Object [] args)`.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `arg` - use this argument. May be null (this will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### invokeStaticMethod

          public static Object invokeStaticMethod(Class<?> objectClass,
                                                  String methodName,
                                                  Object[] args)
                                           throws NoSuchMethodException,
                                                  IllegalAccessException,
                                                  InvocationTargetException

      Invoke a named static method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args)`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      This is a convenient wrapper for `invokeStaticMethod(Class objectClass,String methodName,Object [] args,Class[] parameterTypes)`.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### invokeStaticMethod

          public static Object invokeStaticMethod(Class<?> objectClass,
                                                  String methodName,
                                                  Object[] args,
                                                  Class<?>[] parameterTypes)
                                           throws NoSuchMethodException,
                                                  IllegalAccessException,
                                                  InvocationTargetException

      Invoke a named static method whose parameter type matches the object type.

      The behaviour of this method is less deterministic than `invokeExactStaticMethod(Class objectClass,String methodName,Object [] args,Class[] parameterTypes)`. It loops through all methods with names that match and then executes the first it finds with compatible parameters.

      This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
        `parameterTypes` - match these parameters - treat null as empty array
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### invokeExactStaticMethod

          public static Object invokeExactStaticMethod(Class<?> objectClass,
                                                       String methodName,
                                                       Object arg)
                                                throws NoSuchMethodException,
                                                       IllegalAccessException,
                                                       InvocationTargetException

      Invoke a static method whose parameter type matches exactly the object type.

      This is a convenient wrapper for `invokeExactStaticMethod(Class objectClass,String methodName,Object [] args)`.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `arg` - use this argument. May be null (this will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### invokeExactStaticMethod

          public static Object invokeExactStaticMethod(Class<?> objectClass,
                                                       String methodName,
                                                       Object[] args)
                                                throws NoSuchMethodException,
                                                       IllegalAccessException,
                                                       InvocationTargetException

      Invoke a static method whose parameter types match exactly the object types.

      This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

      Parameters:
        `objectClass` - invoke static method on this class
        `methodName` - get method with this name
        `args` - use these arguments - treat null as empty array (passing null will result in calling the parameterless method with name `methodName`).
      Returns:
        The value returned by the invoked method
      Throws:
        `NoSuchMethodException` - if there is no such accessible method
        `InvocationTargetException` - wraps an exception thrown by the method invoked
        `IllegalAccessException` - if the requested method is not accessible via reflection
      Since:
        1.8.0

    - #### getAccessibleMethod

          public static Method getAccessibleMethod(Class<?> clazz,
                                                   String methodName,
                                                   Class<?> parameterType)

      Return an accessible method (that is, one that can be invoked via reflection) with given name and a single parameter. If no such method can be found, return `null`. Basically, a convenience wrapper that constructs a `Class` array for you.

      Parameters:
        `clazz` - get method from this class
        `methodName` - get method with this name
        `parameterType` - taking this type of parameter
      Returns:
        The accessible method

    - #### getAccessibleMethod

          public static Method getAccessibleMethod(Class<?> clazz,
                                                   String methodName,
                                                   Class<?>[] parameterTypes)

      Return an accessible method (that is, one that can be invoked via reflection) with given name and parameters. If no such method can be found, return `null`. This is just a convenient wrapper for `getAccessibleMethod(Method method)`.

      Parameters:
        `clazz` - get method from this class
        `methodName` - get method with this name
        `parameterTypes` - with these parameters types
      Returns:
        The accessible method

    - #### getAccessibleMethod

          public static Method getAccessibleMethod(Method method)

      Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method. If no such method can be found, return `null`.

      Parameters:
        `method` - The method that we wish to call
      Returns:
        The accessible method

    - #### getAccessibleMethod

          public static Method getAccessibleMethod(Class<?> clazz,
                                                   Method method)

      Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method. If no such method can be found, return `null`.

      Parameters:
        `clazz` - The class of the object
        `method` - The method that we wish to call
      Returns:
        The accessible method
      Since:
        1.8.0

    - #### getMatchingAccessibleMethod

          public static Method getMatchingAccessibleMethod(Class<?> clazz,
                                                           String methodName,
                                                           Class<?>[] parameterTypes)

      Find an accessible method that matches the given name and has compatible parameters. Compatible parameters mean that every method parameter is assignable from the given parameters. In other words, it finds a method with the given name that will take the parameters given.

      This method is slightly undeterministic since it loops through methods names and return the first matching method.

      This method is used by `invokeMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`.

      This method can match primitive parameter by passing in wrapper classes. For example, a `Boolean` will match a primitive `boolean` parameter.

      Parameters:
        `clazz` - find method in this class
        `methodName` - find method with this name
        `parameterTypes` - find method with compatible parameters
      Returns:
        The accessible method

    - #### isAssignmentCompatible

          public static final boolean isAssignmentCompatible(Class<?> parameterType,
                                                             Class<?> parameterization)

      Determine whether a type can be used as a parameter in a method invocation. This method handles primitive conversions correctly.

      In order words, it will match a `Boolean` to a `boolean`, a `Long` to a `long`, a `Float` to a `float`, a `Integer` to a `int`, and a `Double` to a `double`. Now logic widening matches are allowed. For example, a `Long` will not match a `int`.

      Parameters:
        `parameterType` - the type of parameter accepted by the method
        `parameterization` - the type of parameter being tested
      Returns:
        true if the assignment is compatible.

    - #### getPrimitiveWrapper

          public static Class<?> getPrimitiveWrapper(Class<?> primitiveType)

      Gets the wrapper object class for the given primitive type class. For example, passing `boolean.class` returns `Boolean.class`
      Parameters:
        `primitiveType` - the primitive type class for which a match is to be found
      Returns:
        the wrapper type associated with the given primitive or null if no match is found

    - #### getPrimitiveType

          public static Class<?> getPrimitiveType(Class<?> wrapperType)

      Gets the class for the primitive type corresponding to the primitive wrapper class given. For example, an instance of `Boolean.class` returns a `boolean.class`.
      Parameters:
        `wrapperType` - the
      Returns:
        the primitive type class corresponding to the given wrapper class, null if no match is found

    - #### toNonPrimitiveClass

          public static Class<?> toNonPrimitiveClass(Class<?> clazz)

      Find a non primitive representation for given primitive class.
      Parameters:
        `clazz` - the class to find a representation for, not null
      Returns:
        the original class if it not a primitive. Otherwise the wrapper class. Not null

Copyright © 2000–2016 The Apache Software Foundation. All rights reserved.